﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DataPresenter;
using System.Diagnostics;

namespace SmartFieldLabels
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        FieldPosition positionBefore;
        string customizations = null;
        public Window1()
        {
            InitializeComponent();
            xamDataGrid1.FieldPositionChanging += new EventHandler<Infragistics.Windows.DataPresenter.Events.FieldPositionChangingEventArgs>(xamDataGrid1_FieldPositionChanging);
            xamDataGrid1.FieldPositionChanged += new EventHandler<Infragistics.Windows.DataPresenter.Events.FieldPositionChangedEventArgs>(xamDataGrid1_FieldPositionChanged);
        }

        void xamDataGrid1_FieldPositionChanging(object sender, Infragistics.Windows.DataPresenter.Events.FieldPositionChangingEventArgs e)
        {
            customizations = xamDataGrid1.SaveCustomizations();
            positionBefore = e.Field.ActualPosition;
        }

        void xamDataGrid1_FieldPositionChanged(object sender, Infragistics.Windows.DataPresenter.Events.FieldPositionChangedEventArgs e)
        {
            // Moving master label
            if (e.Field is UnboundField)
            {
                FieldPosition fp = e.Field.ActualPosition;
                bool forwardMoving = fp.Column > positionBefore.Column ? true : false;
                int delta = fp.Column - positionBefore.Column;

                // Master labels take care of their sub label movement
                if (e.Field.Name == "People")
                {
                    e.Field.Owner.Fields["PersonFirstName"].ActualPosition = new FieldPosition(e.Field.Owner.Fields["PersonFirstName"].ActualPosition.Column + delta, 1, 1, 1);
                    e.Field.Owner.Fields["PersonLastName"].ActualPosition = new FieldPosition(e.Field.Owner.Fields["PersonLastName"].ActualPosition.Column + delta, 1, 1, 1);

                    e.Field.Owner.Fields["CompanyName"].ActualPosition = new FieldPosition(e.Field.Owner.Fields["CompanyName"].ActualPosition.Column - delta, 1, 1, 1);
                    e.Field.Owner.Fields["CompanyDescription"].ActualPosition = new FieldPosition(e.Field.Owner.Fields["CompanyDescription"].ActualPosition.Column - delta, 1, 1, 1);
                }

                if (e.Field.Name == "Company")
                {
                    e.Field.Owner.Fields["CompanyName"].ActualPosition = new FieldPosition(e.Field.Owner.Fields["CompanyName"].ActualPosition.Column + delta, 1, 1, 1);
                    e.Field.Owner.Fields["CompanyDescription"].ActualPosition = new FieldPosition(e.Field.Owner.Fields["CompanyDescription"].ActualPosition.Column + delta, 1, 1, 1);

                    e.Field.Owner.Fields["PersonFirstName"].ActualPosition = new FieldPosition(e.Field.Owner.Fields["PersonFirstName"].ActualPosition.Column - delta, 1, 1, 1);
                    e.Field.Owner.Fields["PersonLastName"].ActualPosition = new FieldPosition(e.Field.Owner.Fields["PersonLastName"].ActualPosition.Column - delta, 1, 1, 1);
                }
            }
                // moving sub label
            else
            {
                // get the master label of a sub label
                var masterField = from Field f in e.Field.Owner.Fields
                                  where f.Name.ToString().Contains(e.Field.Tag.ToString())
                                  select f;

                if (masterField != null)
                {
                    if (e.Field.ActualPosition.Column >= masterField.ElementAt(0).ActualPosition.Column && e.Field.ActualPosition.Column <= masterField.ElementAt(0).ActualPosition.Column+1)
                    {
                        Debug.WriteLine("Allowed move");
                    }
                    else
                    {
                        Debug.WriteLine("Not allowed move");
                        xamDataGrid1.LoadCustomizations(customizations);
                    }
                }
            }
        }
    }
}
